<?php
/**
 * Save setting.
 * 
 * @access public
 * @return void
 */
public function saveSetting()
{
    $errors = '';
    if(!$this->post->payment) $errors['payment'] = array($this->lang->order->paymentRequired);
    if(!$this->post->confirmLimit) $errors['confirmLimit'] = array($this->lang->order->confirmLimitRequired);
    if(in_array('alipay', $this->post->payment) and strlen($this->post->pid) != 16) $errors['pid'] = array($this->lang->order->placeholder->pid);
    if(in_array('alipay', $this->post->payment) and strlen($this->post->key) != 32) $errors['key'] = array($this->lang->order->placeholder->key);
    if(in_array('alipay', $this->post->payment) and !validater::checkEmail($this->post->email)) $errors['email'] = array(sprintf($this->lang->error->email, $this->lang->order->alipayEmail));
    if(!empty($errors)) return array('result' => 'fail', 'message' => $errors);

    $shopSetting = array();
    $shopSetting['payment']      = join(',', $this->post->payment);
    $shopSetting['confirmLimit'] = $this->post->confirmLimit;
    $shopSetting['sendto']       = join(',', $this->post->sendto);
    $this->loadModel('setting')->setItems('system.common.shop', $shopSetting);

    $alipaySetting = array();
    $alipaySetting['pid']   = $this->post->pid;
    $alipaySetting['key']   = $this->post->key;
    $alipaySetting['email'] = $this->post->email;
    $result = $this->loadModel('setting')->setItems('system.common.alipay', $alipaySetting);

    $wechatpaySetting = array();
    $wechatpaySetting['appid']     = $this->post->appid;
    $wechatpaySetting['mch_id']    = $this->post->mch_id;
    $wechatpaySetting['apikey']    = $this->post->apikey;
    $wechatpaySetting['appsecret'] = $this->post->appsecret;
    $result = $this->loadModel('setting')->setItems('system.common.wechatpay', $wechatpaySetting);

    return array('result' => 'success', 'message' => $this->lang->saveSuccess);
}
