<?php
/**
 * Get users List.
 *
 * @param object  $pager
 * @access public
 * @return object 
 */
public function getCustomerList($pager = null, $user = '', $provider = '')
{
    $users = $this->dao->setAutolang(false)
        ->select('u.*, o.provider as provider, openID as openID')->from(TABLE_USER)->alias('u')
        ->leftJoin(TABLE_OAUTH)->alias('o')->on('u.account = o.account')->where('1')
        ->beginIF($user)
        ->andWhere('u.account')->like("%{$user}%")
        ->orWhere('u.realname')->like("%{$user}%")
        ->orWhere('u.email')->like("%{$user}%")
        ->fi()
        ->beginIF($provider)->andWhere('o.provider')->like("%{$provider}%")->fi()
        ->andWhere('u.isCustomer')->eq('1')
        ->orderBy('id_asc')
        ->page($pager)
        ->fetchAll('account');

    foreach($users as $user)
    {
        $user->realname  = $this->computeRealname($user);
        $user->realnames = json_decode($user->realnames);
    }

    return $users;
}


