<?php
public function addOAuthAccount($account, $provider, $userInfo)
{
    $openUser = $this->dao->select('*')->from(TABLE_OAUTH)->where('provider')->eq($provider)->andWhere('openID')->eq($userInfo->openid)->fetch();

    if($account != 'guest')
    {
        if(empty($openUser))
        {
            return $this->dao->replace(TABLE_OAUTH)
                ->set('account')->eq($account)
                ->set('provider')->eq($provider)
                ->set('openID')->eq($openID)
                ->set('lang')->eq('all')
                ->exec();
        }
    }
    else
    {
        if(empty($openUser))
        {
            $oauth = new stdclass();
            $oauth->openID   = $userInfo->openid;
            $oauth->provider = 'wechat';
            $oauth->account  = uniqid('wx_');
            $this->dao->insert(TABLE_OAUTH)->data($oauth)->exec();

            $user = new stdclass();
            $user->public   = $public;
            $user->nickname = $userInfo->nickname;
            $user->realname = $userInfo->nickname;
            $user->address  = $userInfo->country . ' ' . $userInfo->province . ' ' . $userInfo->city;
            $user->join     = date('Y-m-d H:i:s', $userInfo->subscribe_time);

            if($userInfo->sex == 0) $user->gender = 'u';
            if($userInfo->sex == 1) $user->gender = 'm';
            if($userInfo->sex == 2) $user->gender = 'f';
            $user->account = $oauth->account;
            $this->dao->insert(TABLE_USER)->data($user, $skip = 'openID,provider')->exec();
            $this->autoLogin($user->account);
        }
        $this->autoLogin($openUser->account);
    }
    return true;
}

/**
 * Get openID of a user.
 * 
 * @param  string    $account 
 * @param  string    $provider 
 * @access public
 * @return string
 */
public function getOpenID($account, $provider)
{
    return $this->dao->select('openID')->from(TABLE_OAUTH)->where('account')->eq($account)
        ->andWhere('provider')->eq($provider)
        ->fetch('openID');
}

/**
 * Auto login.
 * 
 * @param  string    $account 
 * @access public
 * @return void
 */
public function autoLogin($account)
{
    $user = $this->getByAccount($account);
    if(!$user) return false;

    $browser = helper::getBrowser() . ' ' . helper::getBrowserVersion();
    $os      = helper::getOS();
    $this->dao->update(TABLE_USER)->set('browser')->eq($browser)->set('os')->eq($os)->where('id')->eq($user->id)->exec();
    if(dao::isError()) return false;

    $user->rights  = $this->authorize($user);
    $user->loginIP = helper::getRemoteIP();
    $this->session->set('user', $user);
    $this->app->user = $this->session->user;
}
